# -*- coding: utf-8 -*-
__author__ = 'TUMCIVIL'
__version__ = '2.0.0'
__title__ = 'เซ็ตค่าระดับยอดเสา\nไปท้องคานใน Link'
__doc__ = """Created by : TUMCIVIL TEAM
Version : 2.0.0
Update : วันที่ 03-03-2025
_________________________________________________________________
รายการ :
เซ็ตระดับยอดเสาไประดับท้องคานใน Link

_________________________________________________________________
ข้อจำกัดการใช้งาน :
1.ไม่สามารถใช้กับเสาที่ Slope ได้
2.ไม่สามารถใช้กับเสาที่สร้างจาก Model In-Place ได้
3.ใช้ได้เฉพาะ Revit Link เท่านั้น
_________________________________________________________________
วิธีการใช้ :
1.เลือกคานใน Link
2.เลือกเสาที่ต้องการเช็ตระดับยอดเสา ออกกด Esc

   

 """
# for timing -------------------------------------------------------------------
# import pyrevit.coreutils as cor
# from pyrevit.coreutils import Timer
# timer = Timer()
# ------------------------------------------------------------------------------
import sys
import re
import Autodesk
from Autodesk.Revit.DB import *
from Autodesk.Revit.UI import *
import Autodesk.Revit.DB as DB
from Autodesk.Revit.DB.Structure import *
from Autodesk.Revit.DB.Structure import Rebar as rb
import pyrevit

import  os
from pyrevit import forms, revit
from Autodesk.Revit.DB import *
from Autodesk.Revit.DB import (BuiltInParameter)

#>>>>>>>>>> .NET IMPORTS
import clr
clr.AddReference("System.Windows.Forms")
clr.AddReference("System")
from System.Collections.Generic import List
from System.Windows.Controls import ComboBoxItem
import wpf
from Autodesk.Revit.UI.Selection    import ISelectionFilter, ObjectType, Selection

#>>>>>>>>>> CUSTOM IMPORTS
from Snippets._convert_units import convert_internal_units
from Snippets._level import levels,get_levels_walls,get_levels_columns
from Snippets._level import *
from Selection._select_element import CustomISelectionFilter, pick_column
from System.Collections.ObjectModel import ObservableCollection
from System.ComponentModel import INotifyPropertyChanged

doc   = __revit__.ActiveUIDocument.Document
uidoc = __revit__.ActiveUIDocument
app   = __revit__.Application

#>>>>>>>>> LIMIT SELECTION
class CustomISelectionFilter(ISelectionFilter):
    """Filter user selection to certain element."""
    def __init__(self, cats):
        self.cats = cats
        # print("self.cats = {}".format(self.cats))
    def AllowElement(self, e):
        if str(e.Category.Id) == str(self.cats):
            return True
        #     print("return = True")
        # print("return = False")
        return False

class ISelectionFilter_Classes(ISelectionFilter):
    def __init__(self, allowed_types):
        """ ISelectionFilter made to filter with types
        :param allowed_types: list of allowed Types"""
        self.allowed_types = allowed_types

    def AllowElement(self, element):
        if type(element) in self.allowed_types:
            return True
        # else:
        #     return False

#>>>>>>>>>> PICK COLUMN
def pick_beam(given_uidoc = uidoc,text = "เลือกคาน"):
    """Function to promt user to select a column element in Revit UI."""
    beam_ref = given_uidoc.Selection.PickObject(ObjectType.Element, CustomISelectionFilter("-2001320"), text)    # -2001320 <- Id of OST_StructuralFraming
    beam     = given_uidoc.Document.GetElement(beam_ref)
    return beam
def pick_column(given_uidoc = uidoc,text = "เลือกเสา" ):
    """Function to promt user to select a column element in Revit UI."""
    # forms.WarningBar(title='Select Walls.')
    column_ref = given_uidoc.Selection.PickObject(ObjectType.Element, CustomISelectionFilter("-2001330"), text)    # -2001330 <- Id of OST_StructuralColumns
    column     = given_uidoc.Document.GetElement(column_ref)
    return column
def pick_footing(given_uidoc = uidoc,text = "เลือกฐานราก" ):
    """Function to promt user to select a column element in Revit UI."""
    # forms.WarningBar(title='Select Walls.')
    footing_ref = given_uidoc.Selection.PickObject(ObjectType.Element, CustomISelectionFilter("-2001300"), text)    # -2001330 <- Id of OST_StructuralFoundation
    footing     = given_uidoc.Document.GetElement(footing_ref)
    return footing

def pick_floor(given_uidoc = uidoc,text = ""):
    """Function to promt user to select a column element in Revit UI."""
    # beam_ref = given_uidoc.Selection.PickObject(ObjectType.LinkedElement, CustomISelectionFilter("-2000032"), text)    # -2001320 <- Id of OST_StructuralFraming
    floor_ref = given_uidoc.Selection.PickObject(ObjectType.Element, CustomISelectionFilter("-2000032"), text)    # -2001320 <- Id of OST_StructuralFraming
    floor     = given_uidoc.Document.GetElement(floor_ref)
    # print("TYPE BEAM = {}".format(type(beam)))
    return floor

def get_selected_walls(uidoc, exitscript = True):
    """Function to Pick Walls. Currently selected walls will be pre-selected."""
    doc       = uidoc.Document
    selection = uidoc.Selection  # type: Selection

    selected_elements = [doc.GetElement(e_id) for e_id in selection.GetElementIds()]
    selected_walls    = [e for e in selected_elements if type(e) == Wall]


    ref_walls         = [Reference(r) for r in selected_walls]
    ref_preselection  = List[Reference](ref_walls)

    # Pick Walls (exterior walls are preselected)
    ISF_Rooms      = ISelectionFilter_Classes([Wall,])
    selected_walls = []

    try:
        with forms.WarningBar(title='Select Walls.'):
            ref_selected_walls = selection.PickObjects(ObjectType.Element,
                                                       ISF_Rooms,
                                                       'Select Rooms',
                                                       ref_preselection)

        selected_walls  = [doc.GetElement(ref) for ref in ref_selected_walls]
    except:
        pass

    if not selected_walls:
        error_msg = 'No Walls were selected.\nPlease Try Again'
        forms.alert(error_msg, title='Wall Selection has Failed.', exitscript=exitscript)

    return selected_walls

def get_selected_beams(uidoc, exitscript = True):
    """Function to Pick Beams. Currently selected beams will be pre-selected."""
    doc       = uidoc.Document
    selection = uidoc.Selection  # type: Selection

    selected_beams = []
    # ISF_Rooms      = CustomISelectionFilter("-2001352")
    ISF_Rooms      = CustomISelectionFilter("-2001320")
    selected_elements = [doc.GetElement(e_id) for e_id in selection.GetElementIds()]
    selected_beams    = [e for e in selected_elements]

    ref_beams         = [Reference(r) for r in selected_beams]
    ref_preselection  = List[Reference](ref_beams)

    # Pick Beams (exterior walls are preselected)

    try:
        with forms.WarningBar(title='โปรดเลือกคานที่เชื่อมหัวเสาเสร็จแล้วกด Finish.'):
            ref_selected_beams = selection.PickObjects(ObjectType.Element,
                                                       ISF_Rooms,
                                                       'โปรดเลือกคานเสร็จแล้วกด Finish',
                                                       ref_preselection)

        selected_beams  = [doc.GetElement(ref) for ref in ref_selected_beams]
    except:
        pass

    if not selected_beams:
        error_msg = 'No Beams were selected.\nPlease Try Again'
        forms.alert(error_msg, title='Beams Selection has Failed.', exitscript=exitscript)

    return selected_beams

def get_selected_columns(uidoc, exitscript = True):
    """Function to Pick Beams. Currently selected beams will be pre-selected."""
    doc       = uidoc.Document
    selection = uidoc.Selection  # type: Selection

    selected_columns = []
    # ISF_Rooms      = CustomISelectionFilter("-2001352")
    ISF_Rooms      = CustomISelectionFilter("-2001330")
    selected_elements = [doc.GetElement(e_id) for e_id in selection.GetElementIds()]
    selected_columns    = [e for e in selected_elements]

    ref_columns         = [Reference(r) for r in selected_columns]
    ref_preselection  = List[Reference](ref_columns)

    # Pick Columns (exterior walls are preselected)

    try:
        with forms.WarningBar(title='โปรดเลือกเสาที่ต้องการเชื่อมกับหลังฐานรากเสร็จแล้วกด Finish.'):
            ref_selected_columns = selection.PickObjects(ObjectType.Element,
                                                       ISF_Rooms,
                                                       'โปรดเลือกคานเสร็จแล้วกด Finish',
                                                       ref_preselection)

        selected_columns  = [doc.GetElement(ref) for ref in ref_selected_columns]
    except:
        pass

    if not selected_columns:
        error_msg = 'No Beams were selected.\nPlease Try Again'
        forms.alert(error_msg, title='Beams Selection has Failed.', exitscript=exitscript)

    return selected_columns

def get_selected_elements(uidoc = uidoc, exitscript=True):
    """Property that retrieves selected views or promt user to select some from the dialog box."""
    doc       = uidoc.Document
    selection = uidoc.Selection  # type: Selection

    try:
        selected_elements = [doc.GetElement(e_id) for e_id in selection.GetElementIds()]
        if not selected_elements:
            forms.alert("No elements  were selected.\nPlease, try again.", exitscript=exitscript)
    except:
        return

    return selected_elements


if __name__ == '__main__':

    out = []
    out3 = []
    levels_model = levels()

    # >>>>>>>>>> SELECT MAIN BEAM

    try:    
        picked_object = uidoc.Selection.PickObject(ObjectType.LinkedElement, "เลือกคานตัวหลักใน link")
        Selected_beam = doc.GetElement(picked_object).GetLinkDocument().GetElement(picked_object.LinkedElementId)

    except: forms.alert("Script is canceled.",exitscript=True,title="Script Canceled.")


    if Selected_beam.Category.Id.IntegerValue == int(BuiltInCategory.OST_StructuralFraming):
        # print("IsBeam = True")
        Main_Top_Constraint     = Selected_beam.get_Parameter(BuiltInParameter.STRUCTURAL_ELEVATION_AT_TOP).AsDouble()
        Main_Bottom_Constraint  = Selected_beam.get_Parameter(BuiltInParameter.STRUCTURAL_ELEVATION_AT_BOTTOM).AsDouble()

        for i in levels_model:
            if Main_Bottom_Constraint < i[1] and i == levels_model[0] :
                Main_Top_Level_value =i[1]
                Main_Top_Level =i[2]
            elif Main_Bottom_Constraint >= i[1] :
                Main_Top_Level_value =i[1]
                Main_Top_Level =i[2]

        match_top_offset = Main_Bottom_Constraint-Main_Top_Level_value

        with forms.WarningBar(title="เลือกเสาชนหลังคาน: (ออกกด 'Esc')", handle_esc=True):
            while True:

                #>>>>>>>>>> PICK Columns
                try:    Match_column = pick_column(uidoc)
                except: break
                if not Match_column: break
                levels_column = get_levels_columns(levels_model,Match_column)
                Top_elevation = levels_column[1]
                Bottom_elevation = levels_column[0]



                with Transaction(doc, "Reinforce") as t:
                    t.Start()
                    if Top_elevation > Bottom_elevation:
                        Match_column.get_Parameter(BuiltInParameter.SCHEDULE_TOP_LEVEL_PARAM).Set(Main_Top_Level)
                        Match_column.get_Parameter(BuiltInParameter.SCHEDULE_TOP_LEVEL_OFFSET_PARAM).Set(match_top_offset)
                    elif Top_elevation < Bottom_elevation:
                        Match_column.get_Parameter(BuiltInParameter.SCHEDULE_BASE_LEVEL_PARAM).Set(Main_Top_Level)
                        Match_column.get_Parameter(BuiltInParameter.SCHEDULE_BASE_LEVEL_OFFSET_PARAM).Set(match_top_offset)

                    t.Commit()
    else:
        forms.alert("Beam isn't selected then exited.", exitscript=True, title="Script Canceled.")







# for timing -------------------------------------------------------------------
# print("====" * 20)
# endtime = timer.get_time()
# print("Time been used = {} sec.".format(endtime))
# currentDate = cor.current_date()
# currentTime = cor.current_time()
# print ("Date : {} ; {}".format(currentDate,currentTime))
# print ("Credited by : {}".format(__author__))
# print("====" * 20)
# ------------------------------------------------------------------------------